diff --git a/drupal7/sites/all/modules/l10n_update/l10n_update.project.inc b/drupal7/sites/all/modules/l10n_update/l10n_update.project.inc
index 8257be9b..f0129703 100644
--- a/drupal7/sites/all/modules/l10n_update/l10n_update.project.inc
+++ b/drupal7/sites/all/modules/l10n_update/l10n_update.project.inc
@@ -25,12 +25,16 @@
 /**
  * Rebuild project list
  *
+ * @param $refresh
+ *   TRUE: Refresh project list.
+ *
  * @return array
+ *   Array of project objects to be considered for translation update.
  */
-function l10n_update_build_projects() {
+function l10n_update_build_projects($refresh = FALSE) {
   module_load_include('inc', 'l10n_update');
   // Get all stored projects, including disabled ones
-  $current = l10n_update_get_projects(NULL, TRUE);
+  $current = l10n_update_get_projects($refresh, TRUE);
   // Now get the new project list, just enabled ones
   $projects = l10n_update_project_list();
 
@@ -47,12 +51,25 @@ function l10n_update_build_projects() {
     $projects_info = update_get_available(TRUE);
   }
   foreach ($projects as $name => $data) {
+
+    // Force update fetch of project data in cases where Drupal's performance
+    // optimized approach is missing out on some projects.
+    // @see http://drupal.org/node/1671570#comment-6216090
+    if (module_exists('update') && !isset($projects_info[$name])) {
+      module_load_include('fetch.inc', 'update');
+      _update_process_fetch_task($data);
+      $available = _update_get_cached_available_releases();
+      if (!empty($available[$name])) {
+        $projects_info[$name] = $available[$name];
+      }
+    }
+
     if (isset($projects_info[$name]['releases']) && $projects_info[$name]['project_status'] != 'not-fetched') {
       // Find out if a dev version is installed.
       if (preg_match("/^[0-9]+\.x-([0-9]+)\..*-dev$/", $data['info']['version'], $matches)) {
         // Find a suitable release to use as alternative translation.
         foreach ($projects_info[$name]['releases'] as $project_release) {
-          // The first release with the same major release number which is not 
+          // The first release with the same major release number which is not
           // a dev release is the one. Releases are sorted the most recent first.
           if ($project_release['version_major'] == $matches[1] &&
               (!isset($project_release['version_extra']) || $project_release['version_extra'] != 'dev')) {
@@ -61,11 +78,6 @@ function l10n_update_build_projects() {
           }
         }
       }
-      elseif ($name == "drupal" || preg_match("/HEAD/", $data['info']['version'], $matches)) {
-        // Pick latest available release.
-        $release = array_shift($projects_info[$name]['releases']);
-      }
-
       if (!empty($release['version'])) {
         $data['info']['version'] = $release['version'];
       }
@@ -101,7 +113,13 @@ function l10n_update_build_projects() {
     }
     // Create / update project record
     $update = empty($current[$name]) ? array() : array('name');
-    drupal_write_record('l10n_update_project', $project, $update);
+    // @todo Use db_merge() to avoid problems with saving existing projects.
+    try {
+      drupal_write_record('l10n_update_project', $project, $update);
+    }
+    catch (Exception $e) {
+      watchdog('l10n_update', 'Could not insert a project into the l10n_update_project table, possibly because it already exists.', NULL, WATCHDOG_INFO);
+    }
     $projects[$name] = $project;
   }
   return $projects;
@@ -136,7 +154,7 @@ function l10n_update_project_refresh($modules) {
   $projects = array();
 
   // Get all current projects, including the recently installed.
-  $current_projects = l10n_update_build_projects();
+  $current_projects = l10n_update_build_projects(TRUE);
   // Collect project data of newly installed projects.
   foreach ($modules as $name) {
     if (isset($current_projects[$name])) {
diff --git a/drupal7/sites/all/themes/bluemasters/bluemasters.info b/drupal7/sites/all/themes/bluemasters/bluemasters.info
index e5d7108c..6c1ee44f 100644
--- a/drupal7/sites/all/themes/bluemasters/bluemasters.info
+++ b/drupal7/sites/all/themes/bluemasters/bluemasters.info
@@ -46,9 +46,9 @@ settings[responsive_menu_switchwidth]='960'
 settings[responsive_menu_topoptiontext]= 'Select a page'
 
 
-; Information added by drupal.org packaging script on 2013-05-22
-version = "7.x-2.0"
+; Information added by Drupal.org packaging script on 2014-04-08
+version = "7.x-2.1"
 core = "7.x"
 project = "bluemasters"
-datestamp = "1369232413"
+datestamp = "1396987265"
 
diff --git a/drupal7/sites/all/themes/bluemasters/template.php b/drupal7/sites/all/themes/bluemasters/template.php
index 347f5cf7..9617cf17 100644
--- a/drupal7/sites/all/themes/bluemasters/template.php
+++ b/drupal7/sites/all/themes/bluemasters/template.php
@@ -18,13 +18,13 @@ if (theme_get_setting('slideshow_js','bluemasters')):
 	drupal_add_js(drupal_get_path('theme', 'bluemasters') . '/js/jquery.flexslider-min.js');
 
 	//Initialize slideshow using theme settings
-	$effect=theme_get_setting('slideshow_effect','bluemasters');
-	$effect_time=theme_get_setting('slideshow_effect_time','bluemasters')*1000;
-	$slideshow_controls=theme_get_setting('slideshow_controls','bluemasters');
-	$slideshow_random=theme_get_setting('slideshow_random','bluemasters');
-	$slideshow_pause=theme_get_setting('slideshow_pause','bluemasters');
-	$slideshow_touch=theme_get_setting('slideshow_touch','bluemasters');
-	$animation_time=theme_get_setting('slideshow_animation_time','bluemasters')*1000;
+    $effect=theme_get_setting('slideshow_effect','bluemasters');
+    $effect_time= (int) theme_get_setting('slideshow_effect_time','bluemasters')*1000;
+    $slideshow_controls=theme_get_setting('slideshow_controls','bluemasters');
+    $slideshow_random=theme_get_setting('slideshow_random','bluemasters');
+    $slideshow_pause=theme_get_setting('slideshow_pause','bluemasters');
+    $slideshow_touch=theme_get_setting('slideshow_touch','bluemasters');
+    $animation_time= (int) theme_get_setting('slideshow_animation_time','bluemasters')*1000;
 
 	drupal_add_js('
 		jQuery.noConflict();
@@ -98,8 +98,9 @@ function bluemasters_page_alter($page) {
  */
 if (theme_get_setting('responsive_menu_state','bluemasters')) {
 
-$responsive_menu_switchwidth=theme_get_setting('responsive_menu_switchwidth','bluemasters');
+$responsive_menu_switchwidth= (int) theme_get_setting('responsive_menu_switchwidth','bluemasters');
 $responsive_menu_topoptiontext=theme_get_setting('responsive_menu_topoptiontext','bluemasters');
+drupal_add_js(array('bluemasters' => array('topoptiontext' => $responsive_menu_topoptiontext)), 'setting');
 
 drupal_add_js(drupal_get_path('theme', 'bluemasters') .'/js/jquery.mobilemenu.min.js');
 drupal_add_js('
@@ -108,8 +109,8 @@ jQuery(document).ready(function($) {
 	$("#navigation > ul.menu, #navigation ul.sf-menu, #navigation .content > ul.menu").mobileMenu({
 	prependTo: "#navigation",
 	combine: false,
-	switchWidth: '.$responsive_menu_switchwidth.',
-	topOptionText: "'.$responsive_menu_topoptiontext.'"
+    switchWidth: '.$responsive_menu_switchwidth.',
+    topOptionText: Drupal.settings.bluemasters[\'topoptiontext\']
 	});
 
 });', array('type' => 'inline', 'scope' => 'footer', 'weight' => 10)
